package com.qmth.cqb.paper.dao;

import java.util.List;
import java.util.Map;

import com.qmth.cqb.utils.enums.PaperStatus;
import com.qmth.cqb.utils.enums.PaperType;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import com.qmth.cqb.paper.model.Paper;

public interface PaperRepo extends MongoRepository<Paper, String>,QueryByExampleExecutor<Paper> {

    List<Paper> findByParams(Map params);

    Page<Paper> findByPaperType(PaperType paperType, Pageable pageable);

    Page<Paper> findByPaperStatus(PaperStatus paperStatus,Pageable pageable);

}
