package com.qmth.cqb.paper.model;

import java.io.Serializable;

import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.DBRef;

import com.qmth.cqb.question.model.Question;

import cn.com.qmth.examcloud.common.dto.question.enums.QuesStructType;

public class PaperDetailUnit implements Serializable, Comparable<PaperDetailUnit> {

    private static final long serialVersionUID = -8854150484922002075L;

    @Id
    private String id;

    @DBRef
    private Paper paper;// 关联的试卷

    private Integer number;// 小题序号

    private Double score;// 小题分数

    @DBRef
    private PaperDetail paperDetail;// 关联的大题

    private QuesStructType questionType;// 小题类型

    @DBRef
    private Question question;// 关联试题

    private String creator;// 创建人id

    private String createTime;// 创建时间

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Paper getPaper() {
        return paper;
    }

    public void setPaper(Paper paper) {
        this.paper = paper;
    }

    public Integer getNumber() {
        return number;
    }

    public void setNumber(Integer number) {
        this.number = number;
    }

    public Double getScore() {
        return score;
    }

    public void setScore(Double score) {
        this.score = score;
    }

    public PaperDetail getPaperDetail() {
        return paperDetail;
    }

    public void setPaperDetail(PaperDetail paperDetail) {
        this.paperDetail = paperDetail;
    }

    public QuesStructType getQuestionType() {
        return questionType;
    }

    public void setQuestionType(QuesStructType questionType) {
        this.questionType = questionType;
    }

    public Question getQuestion() {
        return question;
    }

    public void setQuestion(Question question) {
        this.question = question;
    }

    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public PaperDetailUnit() {
    }

    @Override
    public int compareTo(PaperDetailUnit unit) {
        if (unit != null) {
            if (this.getQuestionType().getId() > unit.getQuestionType().getId()) {
                return 1;
            } else if (this.getQuestionType().getId() == unit.getQuestionType().getId()) {
                return 0;
            }
        }
        return -1;
    }
}
