package com.qmth.cqb.paper.web;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.cqb.paper.model.ExtractConfig;
import com.qmth.cqb.paper.service.ExtractService;

import io.swagger.annotations.ApiOperation;

/**
 * Created by songyue on 16/12/28.
 */
@RestController
@RequestMapping("${api_cqb}/")
public class ExtractController {

    @Autowired
    ExtractService extractService;

    @ApiOperation(value = "抽取试卷", notes = "抽取试卷")
    @GetMapping(value = "/extract/{exam_id}/{course_code}/{group_code}")
    public ResponseEntity extract(@PathVariable String exam_id, @PathVariable String course_code,
            @PathVariable String group_code) {
        Map<String, Object> paperMap = new HashMap<String, Object>();
        ExtractConfig config = extractService.findConfig(Long.parseLong(exam_id), course_code);
        if ("RANDOM_PAPER".equals(config.getPolicy().getKey())) {
            paperMap = extractService.randomPaper(config.getExamId(), config.getCourseCode(), group_code);
        }
        if (paperMap.get("msg").equals("success")) {
            return new ResponseEntity(paperMap.get("paperDto"), HttpStatus.OK);
        } else {
            return new ResponseEntity(paperMap.get("msg"), HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }

    @ApiOperation(value = "抽取单个试题", notes = "抽取单个试题")
    @GetMapping(value = "/extractQues/{ques_id}")
    public ResponseEntity extractQuestion(@PathVariable String ques_id) {
        Map<String, Object> quesMap = new HashMap<String, Object>();
        quesMap = extractService.getQuestionById(ques_id);
        if (quesMap.get("msg").equals("success")) {
            return new ResponseEntity(quesMap.get("quesDto"), HttpStatus.OK);
        } else {
            return new ResponseEntity(quesMap.get("msg"), HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
}
